<?php

namespace Sharplogicians\Keycloak\Controller\Login;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Sharplogicians\Keycloak\Model\Keycloak;
use Magento\Customer\Model\Session as CustomerSession;
use Psr\Log\LoggerInterface;

class Callback extends Action
{    
    protected $keycloak;

    protected $customerSession;
   
    protected $logger;

    public function __construct(
        Context $context,
        Keycloak $keycloak,
        CustomerSession $customerSession,
        LoggerInterface $logger        
    ) {
        $this->keycloak = $keycloak;
        $this->customerSession = $customerSession;        
        $this->logger = $logger;
        parent::__construct($context);
    }

    public function execute()
    {
        $code = $this->getRequest()->getParam('code');
        if ($code) {
            try {
                $tokenResponse = $this->keycloak->exchangeCodeForToken($code);
                if (isset($tokenResponse['access_token'])) {
                    $userInfo = $this->keycloak->getUserInfo($tokenResponse['access_token']);
                    if ($userInfo) {
                        $this->logger->info('User Info: ' . json_encode($userInfo));
                        $customer = $this->keycloak->getOrCreateCustomer($userInfo['email'], $userInfo['name']);
                        $this->customerSession->setCustomerDataAsLoggedIn($customer);
                        echo "<script>window.opener.location.reload(); window.close();</script>";
                    }
                } else {
                    echo "<script>alert('Login failed. Please try again.'); window.close();</script>";
                }
            } catch (\Exception $e) {
                $this->logger->error('Error during Keycloak callback: ' . $e->getMessage());
                echo "<script>alert('Login failed. Please try again.'); window.close();</script>";
            }
        }
        echo "<script>alert('Login failed. Please try again.'); window.close();</script>";
    } 
}
